#include <cstdio>
#include <algorithm>
#include <vector>
using namespace std;

const int NUM_TESTS = 10;
const int TEST_SCORE = 1;
const int MAX_NODES = 1024;

long long NOD(long long a, long long b){
    long long q;
    if(a<b) swap(a,b);
    if(b==0) return a;
    while(b){
        q = a%b;
        a = b;
        b = q;
    }
    return a;
}

int main(int argc, char** argv) {

    FILE *inp, *out, *sol;
    if (!(inp = fopen(argv[1], "rt"))) {
        fprintf(stderr, "Could not open file %s.\n", argv[1]);
        return 0;
    }
    if (!(sol = fopen(argv[2], "rt"))) {
        fprintf(stderr, "Could not open file %s.\n", argv[2]);
        return 0;
    }
    if (!(out = fopen(argv[3], "rt"))) {
        fprintf(stderr, "Could not open file %s.\n", argv[3]);
        return 0;
    }

    int n, m, a, b;
    long long nodes[MAX_NODES], t;
    vector<long long> v;

    fscanf(inp, "%d", &n);
    fscanf(inp, "%d", &m);

    for(int i=0;i<n;i++){
        if(fscanf(out, "%lld", &nodes[i]) < 0)
        {
            fprintf(stdout, "0\n");
            fprintf(stderr, "Not enough node numbers\n");
            return 0;
        }
    }

    for(int i=0;i<m;i++){
        fscanf(inp, "%d %d", &a, &b);
        t = NOD(nodes[a-1],nodes[b-1]);

        //  check for more divisors
        for(int i=2;i<t;i++)
            if(nodes[a-1]%i==0 && nodes[b-1]%i==0){
                fprintf(stdout, "0\n");
                fprintf(stderr, "WA\n");
                return 0;
            }

        // check if current divisor is divisor for another edge
        if(!binary_search(v.begin(), v.end(), t)){
            v.push_back(t);
            sort(v.begin(), v.end());
        }else{
            fprintf(stdout, "0\n");
            fprintf(stderr, "WA\n");
            return 0;
        }
    }

    fprintf(stdout, "%d\n", TEST_SCORE);
    fprintf(stderr, "OK\n");
    return 0;
}
